/****************************************
* dessine une brique
*
* entree :
*   - x, y : position de la brique
*   - w : largeur de la marche
*   - couleur : indique la couleur de la brique
*
* sortie :
*   - aucune
*****************************************/
void brique(int x, int y, int w, boolean couleur) {
    if (couleur)
      fill(255, 0, 0);
    else  
      fill(0, 0, 0);
      
    rect(x, y, w, w);
}

/****************************************
* dessine une ligne
*
* entree :
*   - n : largeur de ligne
*   - x, y : position de la ligne
*   - w : largeur de la marche
*
* sortie :
*   - aucune
*****************************************/
void ligne(int x, int y, int w, int n, boolean couleur) {  
  for(int i = 0; i < n; i++) {
    brique(x + i * w, y, w, couleur);
    
    couleur = !couleur;
  }
}

/****************************************
* escalier bicolore descendant
*
* entree :
*   - n : nombre de marches
*   - x, y : position de l'escalier
*   - w : largeur de la marche
*
* sortie :
*   - aucune
*****************************************/
void descendant(int x, int y, int w, int n) {
  for(int i = 0; i < n; i++)
    ligne(x, y + i * w, w, i + 1, (i % 2) == 0);
}

/****************************************
* escalier bicolore montant
*
* entree :
*   - n : nombre de marches
*   - x, y : position de l'escalier
*   - w : largeur de la marche
*
* sortie :
*   - aucune
*****************************************/
void montant(int x, int y, int w, int n) {
  for(int i = 0; i < n; i++)
    ligne(x + (n-1-i) * w, y + i * w, w, i + 1, false);
}

/****************************************
* escalier bicolore montant
*
* entree :
*   - n : nombre de marches
*   - x, y : position de l'escalier
*   - w : largeur de la marche
*
* sortie :
*   - aucune
*****************************************/
void pyramide(int x, int y, int w, int n) {
  montant(x, y, w, n);
  
  descendant(x + n * w, y, w, n);
}


void setup() {
  size(300, 300);
  
  descendant(0, 0, 20, 5);
  
  montant(180, 0, 20, 5);

  pyramide(0, 180, 20, 5); 
}


